gocek/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('helloworld.urls')),
    path('hiburan/', include('hiburan.urls')),
    path('pasar/', include('pasar_zaldy.urls')),
    path('rumah-sakit/', include('rumah_sakit.urls')),
    path('restoran/', include('restoran.urls')),
    path('account/', include('sistemlogin.urls')),
]

restoran/urls.py
from django.urls import path
from . import views

app_name = 'restoran'

urlpatterns = [
    path('', views.index, name='index'),
    path('add/', views.add, name='add'),
    path('add-food/<str:id>', views.add_food, name='add_food'),
    path('detail/<str:id>', views.detail, name='detail'),
    path('update/<str:id>', views.update, name='update'),

]

restoran/models.py
from django.db import models


class Restoran(models.Model):

    nama = models.CharField(max_length=100)
    alamat = models.TextField()
    picture = models.ImageField(upload_to='images/')
    jenis_pesanan = models.CharField(max_length=100, default='Dine in & Take-away')
    kategori = models.CharField(max_length=50, default='Fast food')
    telepon = models.CharField(max_length=15, default='000000000000')
    time_open = models.TimeField()
    time_close = models.TimeField()

    def __str__(self):
        return self.nama

class Makanan(models.Model):
    id = models.AutoField(primary_key=True)

    nama = models.CharField(max_length=100)
    harga = models.IntegerField()
    picture = models.ImageField(upload_to='images/')
    restoran = models.ForeignKey(Restoran, on_delete=models.CASCADE)

    def __str__(self):
        return self.nama

restoran/forms.py
from django.forms import Form
from django import forms
from .models import Restoran, Makanan

class RestoranForm(Form):
    nama = forms.CharField(max_length=50)
    alamat = forms.CharField(widget=forms.Textarea)
    kategori = forms.CharField(max_length=50)
    jenis_pesanan = forms.CharField(max_length=50)
    telepon = forms.CharField(max_length=15)
    picture = forms.ImageField()
    time_open = forms.TimeField(widget=forms.TimeInput)
    time_close = forms.TimeField(widget=forms.TimeInput)


class MakananForm(Form):
    nama = forms.CharField(max_length=50)
    harga = forms.IntegerField()
    picture = forms.ImageField()

restoran/views.py
from django.shortcuts import render, HttpResponseRedirect, get_object_or_404, reverse
from .forms import RestoranForm, MakananForm
from .models import Restoran, Makanan


def index(request):
    list_restoran = Restoran.objects.all()
    context = {'list_restoran': list_restoran}
    return render(request, 'restoran/index.html', context)

def add(request):
    form = RestoranForm()
    if request.method == 'POST':
        form = RestoranForm(request.POST, request.FILES)
        if form.is_valid():
            nama = form.cleaned_data.get('nama')
            alamat = form.cleaned_data.get('alamat')
            picture = form.cleaned_data.get('picture')
            kategori = form.cleaned_data.get('kategori')
            jenis_pesanan = form.cleaned_data.get('jenis_pesanan')
            time_open = form.cleaned_data.get('time_open')
            time_close = form.cleaned_data.get('time_close')
            telepon = form.cleaned_data.get('telepon')
            obj = Restoran.objects.create(nama=nama,telepon=telepon, alamat=alamat,picture=picture, jenis_pesanan=jenis_pesanan, time_open=time_open, time_close=time_close, kategori=kategori)
            obj.save()
        else:
            print('invalid form')
        return HttpResponseRedirect('/restoran/')
    context = {'form': form}
    return render(request, 'restoran/add.html', context)

def add_food(request, id):
    form = MakananForm()
    if request.method == 'POST':
        form = MakananForm(request.POST, request.FILES)
        if form.is_valid():
            nama = form.cleaned_data.get('nama')
            harga = form.cleaned_data.get('harga')
            picture = form.cleaned_data.get('picture')
            restoran_id = request.POST['restoran_id']
            restoran = get_object_or_404(Restoran, id=restoran_id)
            obj = Makanan.objects.create(nama=nama, harga=harga, picture=picture, restoran=restoran)
            obj.save()
        return HttpResponseRedirect('/restoran/detail/' + id)
    context = {'form': form, 'restoran_id': id}
    return render(request, 'restoran/add_food.html', context)

def detail(request, id):
    restoran = get_object_or_404(Restoran, id=id)
    context = {'restoran': restoran}
    foods = Makanan.objects.all()
    food_exists = False
    if foods:
        context['foods'] = foods
        food_exists = True
    context['food_exists'] = food_exists
    return render(request, 'restoran/detail.html', context)

def update(request, id):
    restoran = Restoran.objects.get(id=id)
    form = RestoranForm()
    if request.method == 'POST':
        form = RestoranForm(request.POST, request.FILES)
        if form.is_valid() or True:
            picture = form.cleaned_data.get('picture')
            kategori = form.cleaned_data.get('kategori')
            time_open = form.cleaned_data.get('time_open')
            time_close = form.cleaned_data.get('time_close')
            telepon = form.cleaned_data.get('telepon')
            restoran.picture = picture
            restoran.kategori = kategori
            restoran.time_open = time_open
            restoran.time_close = time_close
            restoran.telepon = telepon
            restoran.save()
        return HttpResponseRedirect('/restoran/detail/' + id)
    context = {'form': form, 'restoran': restoran}

    return render(request, 'restoran/update.html', context)

restoran/templates/restoran/add.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <link rel="stylesheet" type="text/css" href="{% static 'restoran/restoranstyle.css' %}">
    <title>Tambah Restoran</title>
{% endblock %}
{% block headercontent %}
    <span class="lh-0">Tambah Restoran</span>
{% endblock %}
{% block content %}
    <div class="container" style="margin: auto;">
        <div class="row justify-content-center">
            <div class="card-body "
                 style="border: none; border-radius: 20px; border-color: #2c063c; background-color:#F2F2F2; ">
                <h5 class="card-title h4 mt-0 title">Tambah Restoran</h5>
                <form method="POST" style="margin: 10px;" enctype="multipart/form-data">
                    {% csrf_token %}
                    <div class="form">
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Nama Restoran:
                            </label>
                            <div class="col-sm-10">
                                {{ form.nama }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Alamat:
                            </label>
                            <div class="col-sm-10">
                                {{ form.alamat }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Kategori:
                            </label>
                            <div class="col-sm-10">
                                {{ form.kategori }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Jenis Pesanan:
                            </label>
                            <div class="col-sm-10">
                                {{ form.jenis_pesanan }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Nomor Telepon:
                            </label>
                            <div class="col-sm-10">
                                {{ form.telepon }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Gambar:
                            </label>
                            <div class="col-sm-10">
                                {{ form.picture }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Jam Buka:
                            </label>
                            <div class="col-sm-10">
                                {{ form.time_open }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Jam Tutup:
                            </label>
                            <div class="col-sm-10">
                                {{ form.time_close }}
                            </div>
                        </div>
                        <div class="button d-flex justify-content-center">
                            <input type="submit" value="Simpan" class="btn btn-block" style="border-radius: 25px;
                        font-size: 25px; color: white; background-color:#4180E2;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;"
                                   role="button"/>
                            <a class="btn btn-danger btn-block ml-2" style="border-radius: 25px;
                        font-size: 25px; color: white; background-color:#E24141;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'restoran:index' %}"
                               role="button"><strong>Batal</strong></a>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>

{% endblock %}

restoran/templates/restoran/add_food.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <title>Tambah Makanan</title>
    <link rel="stylesheet" type="text/css" href="{% static 'restoran/restoranstyle.css' %}">
{% endblock %}
{% block headercontent %}
    <span class="lh-0">Tambah Makanan</span>
{% endblock %}
{% block content %}
    <div class="container" style="margin: auto;">
    <br><br>
        <div class="row justify-content-center">
            <div class="card-body "
                 style="border: none; border-radius: 20px; border-color: #2c063c; background-color:#F2F2F2; ">
                <form method="POST" style="margin: 10px;" enctype="multipart/form-data"
                      action="{% url 'restoran:add_food' restoran_id %}">
                    {% csrf_token %}
                    <div class="form">
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Nama Makanan:
                            </label>
                            <div class="col-sm-10">
                                {{ form.nama }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Harga:
                            </label>
                            <div class="col-sm-10">
                                {{ form.harga }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="inputPassword3" class="col-sm-2 form-control-label">
                                Gambar:
                            </label>
                            <div class="col-sm-10">
                                {{ form.picture }}
                            </div>
                        </div>
                        <div class="button d-flex justify-content-center">
                            <input type="submit" value="Simpan" class="btn btn-block" style="border-radius: 25px;
                        font-size: 25px; color: white; background-color:#4180E2;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;"
                                   role="button"/>
                            <a class="btn btn-danger btn-block ml-2" style="border-radius: 25px;
                        font-size: 25px; color: white; background-color:#E24141;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'restoran:index' %}"
                               role="button"><strong>Batal</strong></a>
                        </div>
                    </div>
                    <input type="hidden" name="restoran_id" value="{{ restoran_id }}">
                </form>
            </div>
        </div>
    </div>
{% endblock %}

restoran/templates/restoran/detail.html
{% extends 'base.html' %}
{% block meta %}
    <title>Detail Restoran</title>
    {% load static %}
    <link rel="stylesheet" type="text/css" href="{% static 'restoran/restoranstyle.css' %}">
{% endblock %}
{% block headercontent %}
    <span class="lh-0">{{ restoran.nama }}</span>
{% endblock %}
{% block content %}
    <a class="btn btn-primary btn-block ml-auto"
                               style="font-size: large; color: white; width: 12rem; margin-bottom: 30px ;margin-top: 30px;"
                               href="{% url 'restoran:update' restoran.id %}"
                               role="button">Update</a>
    <div class="container">
        <div class="row">
            <div class="col">
                <img class="detailimg m-3 p-3" src="http://2.bp.blogspot.com/-n4XVTOEePrA/UsNPki9OppI/AAAAAAAAAD8/vvOve1Lqk3E/s1600/5-Restoran-cepat-saji-ist.jpg" alt="image">
            </div>
            <div class="col">
                <div class="fieldlabel m-3 p-3">
                    <b>Alamat</b>
                    <p>{{ restoran.alamat }}</p>
                </div>
                <div class="fieldlabel m-3 p-3">
                    <b>Jam Operasional</b>
                    <p>{{ restoran.time_open }} - {{ restoran.time_close }}</p>
                </div>
                <div class="fieldlabel m-3 p-3">
                    <b>Kategori</b>
                    <p>{{ restoran.kategori }}</p>
                </div>
                <div class="fieldlabel m-3 p-3">
                    <b>Jenis Pemesanan</b>
                    <p>{{ restoran.jenis_pesanan }}</p>
                </div>
                <div class="fieldlabel m-3 p-3">
                    <b>Nomor Telepon</b>
                    <p>{{ restoran.telepon }}</p>
                </div>
            </div>
        </div>
    </div>
    <br>
    <h3>Daftar Makanan</h3>
    <div><a class="btn btn-primary btn-block ml-auto"
            style="font-size: large; color: white; width: 12rem; margin-bottom: 30px ;margin-top: 30px;"
            href="{% url 'restoran:add_food' restoran.id %}" role="button">+ Tambah Makanan</a></div>
    <br>
    <div class="container">
        <div class="row">
            {% if food_exists %}
                {% for food in foods %}
                    {% if food.restoran.id == restoran.id %}
                        <div class="col card text-dark align-items-center">
                            <div class="card-body">
                                <!--foto restoran -->
                                <img class="card-img-top" src="http://2.bp.blogspot.com/-n4XVTOEePrA/UsNPki9OppI/AAAAAAAAAD8/vvOve1Lqk3E/s1600/5-Restoran-cepat-saji-ist.jpg"
                                     alt="Card image">
                                <div class="card-title"><strong>{{ food.nama }}</strong></div>
                                <br>
                                <div class="card-title">Rp{{ food.harga }}</div>
                            </div>
                        </div>
                    {% endif %}
                {% endfor %}
            {% endif %}
        </div>
    </div>
{% endblock %}

restoran/templates/restoran/index.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <link rel="stylesheet" type="text/css" href="{% static 'restoran/restoranstyle.css' %}">
    <title>Restoran</title>
{% endblock %}
{% block headercontent %}
    <span class="lh-0">Restoran & Kafe</span>
{% endblock %}
{% block content %}
    <div class="container" style="margin: auto;">
        <div><a class="btn btn-primary btn-block ml-auto" style="font-size: large; color: white;
    width: 12rem; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'restoran:add' %}" role="button">+ Tambah
            Restoran</a></div>

        <div class="row justify-content-center">
            {% for restoran in list_restoran %}
                <div class="card text-dark align-items-center">

                    <div class="card-body">
                        <!--foto restoran -->
                        <img class="card-img-top" src="http://2.bp.blogspot.com/-n4XVTOEePrA/UsNPki9OppI/AAAAAAAAAD8/vvOve1Lqk3E/s1600/5-Restoran-cepat-saji-ist.jpg"
                             alt="Card image">
                        <div class="card-title"><strong>{{ restoran.nama }}</strong></div>
                        <h6>
                            <strong>Alamat:</strong>
                        </h6>
                        <div class="card-title">{{ restoran.alamat }}</div>
                        <h6>
                            <strong>Jam Operasional:</strong>
                        </h6>
                        <div class="card-title">{{ restoran.time_open }} - {{ restoran.time_close }}</div>

                        <div>
                            <a class="btn btn-primary btn-block ml-auto"
                               style="font-size: large; color: white; width: 12rem; margin-bottom: 30px ;margin-top: 30px;"
                               href="{% url 'restoran:detail' restoran.id %}"
                               role="button">Lihat Detail</a>
                        </div>
                    </div>
                </div>
            {% endfor %}
        </div>

    </div>
    </div>

{% endblock %}

restoran/templates/restoran/update.html
{% extends 'base.html' %}
{% block meta %}
    {% load static %}
    <link rel="stylesheet" type="text/css" href="{% static 'restoran/restoranstyle.css' %}">
    <title>Tambah Restoran</title>
{% endblock %}
{% block headercontent %}
    <span class="lh-0">Update {{ restoran.nama }}</span>
{% endblock %}
{% block content %}
    <br><br><br>
    <div class="container" style="margin: auto;">
        <div class="row justify-content-center">
            <div class="card-body"
                 style="border: none; border-radius: 20px; border-color: #2c063c; background-color:#F2F2F2; ">
                <h5 class="card-title h4 mt-0 title">Update {{ restoran.nama }}</h5>
                <p class="card-text">
                <form method="POST" style="margin: 10px;" enctype="multipart/form-data">
                    {% csrf_token %}
                    <div class="form-group">
                        <div class="form-group row">
                            <label for="nama" class="col-sm-2 form-control-label"><h5>Nama Tempat Makan:</h5></label>
                            <div class="col-sm-10">
                                <input type="text" id="nama" name="nama" value="{{ restoran.nama }}" disabled>
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="picture" class="col-sm-2 form-control-label"><h5>Foto</h5></label>
                            <div class="col-sm-10">
                                {{ form.picture }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="kategori" class="col-sm-2 form-control-label"><h5>Kategori</h5></label>
                            <div class="col-sm-10">
                                {{ form.kategori }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="time_open" class="col-sm-2 form-control-label"><h5>Jam Buka:</h5></label>
                            <div class="col-sm-10">
                                {{ form.time_open }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="time_close" class="col-sm-2 form-control-label"><h5>Jam Tutup:</h5></label>
                            <div class="col-sm-10">
                                {{ form.time_close }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="telepon" class="col-sm-2 form-control-label"><h5>Telepon</h5></label>
                            <div class="col-sm-10">
                                {{ form.telepon }}
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="jenis_pesanan" class="col-sm-2 form-control-label"><h5>Jenis Pemesanan:</h5>
                            </label>
                            <div class="col-sm-10">
                                <input type="text" id="jenis_pesanan" name="jenis_pesanan"
                                       value="{{ restoran.jenis_pesanan }}"
                                       disabled>
                            </div>
                        </div>
                        <div class="form-group row">
                            <label for="alamat" class="col-sm-2 form-control-label"><h5>Alamat</h5></label>
                            <div class="col-sm-10">
                                <input type="text" id="alamat" name="alamat" value="{{ restoran.alamat }}" disabled>
                            </div>
                        </div>
                        <div class="button d-flex justify-content-center">
                            <input type="submit" value="Simpan" class="btn btn-block" style="border-radius: 25px;
                        font-size: 25px; color: white; background-color:#4180E2;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;"
                                   role="button"/>
                            <a class="btn btn-danger btn-block ml-2" style="border-radius: 25px;
                        font-size: 25px; color: white; background-color:#E24141;
                        width: 10em; margin-bottom: 30px ;margin-top: 30px;" href="{% url 'restoran:detail' restoran.id  %}"
                               role="button"><strong>Batal</strong></a>
                        </div>
                    </div>
                </form>
                </p>
            </div>
        </div>
    </div>

{% endblock %}